"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserAction$ = void 0;
/*
 * Copyright (c) 2022-2023 AccelByte Inc. All Rights Reserved
 * This is licensed software from AccelByte Inc, for limitations
 * and restrictions contact your company contract manager.
 */
/**
 * AUTO GENERATED
 */
const sdk_1 = require("@accelbyte/sdk");
const zod_1 = require("zod");
class UserAction$ {
    // @ts-ignore
    constructor(axiosInstance, namespace, cache = false) {
        this.axiosInstance = axiosInstance;
        this.namespace = namespace;
        this.cache = cache;
    }
    /**
     * This API is used to report a game user.&lt;p&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&#34;NAMESPACE:{namespace}:USER:{userId}:ACTION&#34;, action=1 (CREATE)&lt;/li&gt;&lt;/ul&gt;
     */
    createActionReport_ByUserId(userId, data) {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/users/{userId}/actions/report'
            .replace('{namespace}', this.namespace)
            .replace('{userId}', userId);
        const resultPromise = this.axiosInstance.post(url, data, { params });
        return sdk_1.Validate.responseType(() => resultPromise, zod_1.z.unknown(), 'z.unknown()');
    }
}
exports.UserAction$ = UserAction$;
