/*
 * Copyright (c) 2022-2023 AccelByte Inc. All Rights Reserved
 * This is licensed software from AccelByte Inc, for limitations
 * and restrictions contact your company contract manager.
 */
/**
 * AUTO GENERATED
 */
import { CodeGenUtil, SdkCache, Validate } from '@accelbyte/sdk';
import { NamespaceInfoArray } from '../definitions/NamespaceInfoArray.js';
import { NamespacePublisherInfo } from '../definitions/NamespacePublisherInfo.js';
export class Namespace$ {
    // @ts-ignore
    constructor(axiosInstance, namespace, cache = false) {
        this.axiosInstance = axiosInstance;
        this.namespace = namespace;
        this.cache = cache;
    }
    /**
     * Get all namespaces.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: login user&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11303&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: list of namespaces&lt;/li&gt;&lt;/ul&gt;
     */
    getNamespaces(queryParams) {
        const params = { ...queryParams };
        const url = '/basic/v1/public/namespaces';
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => Validate.responseType(() => resultPromise, NamespaceInfoArray, 'NamespaceInfoArray');
        if (!this.cache) {
            return SdkCache.withoutCache(res);
        }
        const cacheKey = url + CodeGenUtil.hashCode(JSON.stringify({ params }));
        return SdkCache.withCache(cacheKey, res);
    }
    /**
     * Get namespace info related publisher namespace.&lt;br&gt;Other detail info: &lt;ul&gt;&lt;li&gt;&lt;i&gt;Required permission&lt;/i&gt;: resource=&lt;b&gt;&#34;NAMESPACE:{namespace}:NAMESPACE&#34;&lt;/b&gt;, action=2 &lt;b&gt;(READ)&lt;/b&gt;&lt;/li&gt;&lt;li&gt;&lt;i&gt;Action code&lt;/i&gt;: 11305&lt;/li&gt;&lt;li&gt;&lt;i&gt;Returns&lt;/i&gt;: Namespace info related publisher namespace&lt;/li&gt;&lt;/ul&gt;
     */
    getPublisher() {
        const params = {};
        const url = '/basic/v1/public/namespaces/{namespace}/publisher'.replace('{namespace}', this.namespace);
        const resultPromise = this.axiosInstance.get(url, { params });
        const res = () => Validate.responseType(() => resultPromise, NamespacePublisherInfo, 'NamespacePublisherInfo');
        if (!this.cache) {
            return SdkCache.withoutCache(res);
        }
        const cacheKey = url + CodeGenUtil.hashCode(JSON.stringify({ params }));
        return SdkCache.withCache(cacheKey, res);
    }
}
